#! /bin/sh
#
#   fine-erase.sh -- ʣ񤭹ߤǰ˥ǥΥǡõ
#
#	0.0: Jul. 12, 2004 by Dai ISHIJIMA (for wpout04)
#	0.1: Feb. 17, 2007 (for wpout08)
#	0.2: May  17, 2020 (for v20, FreeBSD 11.3R)
#	0.3: Dec. 25, 2022 (for ubuntu)
#

stuffs="${1:-fz}"
disk="${2:-ada0}"

if [ ! -w /dev/$disk ]; then
	echo "$0: disk $disk not found or non-writable"
	echo -n "Ok? [y/n]: "
	read ans
	case x"$ans" in
		xy*)	;;
		*)	echo 'canceled'; exit 1;;
	esac
fi

if df | grep "^/dev/$disk" > /dev/null 2>&1 ; then
	echo "$0: disk $disk is mounted, proceed?"
	echo -n "Ok? [yes/no]: "
	read ans
	case x"$ans" in
		xyes)	;;
		*)	echo 'canceled'; exit 1;;
	esac
fi

stuffcmd='./stuff'
if [ ! -x ./stuff ]; then
	echo ''
	echo '** Now, wipe-out works in fall-back mode.'
	echo '** Writing random, pattern, invert are simplified.'
	echo ''
	stuffcmd='sh stuff.sh'
fi

dmesg=/var/run/dmesg.boot
#dname=`sed -n -E "/^${disk}:.*<.*>/p" $dmesg | sed 's/.*\(<.*>\).*/\1/'`
bytes=`sh disksize.sh -b $disk`
cbytes=`sh disksize.sh -c $disk`
cap=`sh disksize.sh -s $disk`

nstuff=0
msg=''
for stuff in `echo $stuffs | sed 's/\(.\)/\1 /g'` ; do
	case x"$stuff" in
		x[0z])	msg="${msg}0," ;;
		x[1f])	msg="${msg}1," ;;
		x[Rr])	msg="${msg}R," ;;
		x[Pp])	msg="${msg}P," ;;
		x[Qq])	msg="${msg}Q," ;;
	esac
	nstuff=$(( $nstuff + 1 ))
done
msg=`echo $msg | sed 's/,$//'`

echo ''; echo ''; echo ''
#echo "*** erase data on ${disk} ${dname}, ${bytes} bytes"
echo "*** erase data on ${disk} ${cap}, ${cbytes} bytes"
echo "    with writing $nstuff times ($msg)  "

echo -n "[Q:1/2] Ok? [y/n]: "
read ans
case x"$ans" in
	xy)	;;
	*)	echo 'canceled'; exit 1;;
esac

echo -n "[Q:2/2] Really? [yes/no]: "
read ans
case x"$ans" in
	xyes)	;;
	*)	echo 'canceled'; exit 1;;
esac


# õΥѥ᡼
bytes=`sh disksize.sh -b $disk`
obs=$(( 1024 * 1024 ))
ibs=1024
icnt=32768
ocnt=32
max=$(( ( $bytes + $obs - 1 ) / $obs ))

#
echo ''

spc='                                                                        '
n=0
while [ $n -lt 18 ] ; do
	echo ''
	n=$(( $n + 1 ))
done
printf "\033"
echo -n '[18A'
printf "\033"
echo -n '7'

stage=0
xstage=1
startsec=`date '+%s'`
totalrems='??? [min]'

for stuff in `echo $stuffs | sed 's/\(.\)/\1 /g'` ; do
	skip=0
	stagestart=`date '+%s'`
	case "$stuff" in
		[0z])	method="'0'" ;;
		[1f])	method="'1'" ;;
		[Rr])	method="random data" ;;
		[Pp])	stuff -g > $PATTERNFIL
			method="random pattern" ;;
		[Qq])	method="inverted pattern" ;;
	esac
	rems='??? [min]'
	skip=0
	printf "\033"
	echo -n '8'
	printf "\033"
	echo -n '7'
	n=0
	while [ $n -lt 18 ] ; do
		echo "$spc"
		n=$(( $n + 1 ))
	done
	while [ $skip -le $max ]; do
		# 
		printf "\033"
		echo -n '8'
		printf "\033"
		echo -n '7'
		# ׻
		cursec=`date '+%s'`
		# С
		p=$(( 100 * $skip / $max ))
		m=$(( 1000 * $skip / $max ))
		q=$(( $p / 2 ))
		i=0
		bar=''
		while [ $i -lt $q ]; do
			bar="$bar"'#'
			i=$(( $i + 1 ))
		done
		while [ $i -lt 50 ]; do
			bar="$bar"'_'
			i=$(( $i + 1 ))
		done
		#
		# Ĥ
		elapsed=$(( $cursec - $stagestart ))
		if [ $m -gt 0 ]; then
			remain=$(( ( 1000 - $m ) * $elapsed / $m + 1 ))
			if [ $remain -gt 120 ]; then
				rems=$(( ( $remain + 59 ) / 60 ))
				rems="${rems} [min]"
			else
				rems="${remain} [sec]"
			fi
		fi
		if [ $elapsed -gt 120 ]; then
			elas=$(( ( $elapsed + 30 ) / 60 ))
			elas="${elas} [min]"
		else
			elas="${elapsed} [sec]"
		fi
		#
		# ΥС
		pp=$(( ( $p + 100 * $stage ) / $nstuff ))
		mm=$(( ( $m + 1000 * $stage ) / $nstuff ))
		q=$(( $pp / 2 ))
		i=0
		totalbar=''
		while [ $i -lt $q ]; do
			totalbar="$totalbar"'#'
			i=$(( $i + 1 ))
		done
		while [ $i -lt 50 ]; do
			totalbar="$totalbar"'_'
			i=$(( $i + 1 ))
		done
		ee=$(( $cursec - $startsec ))
		if [ $mm -gt 0 ]; then
			rr=$(( ( 1000 - $mm ) * $ee / $mm + 1 ))
			if [ $rr -gt 120 ]; then
				totalrems=$(( ( $rr + 59 ) / 60 ))
				totalrems="${totalrems} [min]"
			else
				totalrems="${rr} [sec]"
			fi
		fi
		if [ $ee -gt 120 ]; then
			totalelas=$(( ( $ee + 30 ) / 60 ))
			totalelas="${totalelas} [min]"
		else
			totalelas="${ee} [sec]"
		fi
		#

		echo "erasing data on disk: ${disk}."
		echo "stage ${xstage} of ${nstuff}, ${pp}% done   "
		echo "${totalelas} elapsed, ${totalrems} remains (approx.)   "
		echo ''
		echo "    0%|${totalbar}|100%"
		echo ''
		echo "now writing ${method} onto the disk.  ${p}% done   "
		echo "${elas} elapsed, ${rems} remains (approx.)   "
		echo ''
		echo "    0%|${bar}|100%"
		echo ''
		case x$DEBUG in
			x[Yy]*)
				echo 'now in debug mode...'
				sleep 1
				;;
			*)
				$stuffcmd -$stuff < $PATTERNFIL |
				dd ibs=$ibs obs=$obs seek=$skip \
					count=$icnt of=/dev/$disk
				;;
		esac
		# 롼
		skip=$(( $skip + $ocnt ))
	done
	stage=$(( $stage + 1 ))
	xstage=$(( $xstage + 1 ))
done

echo ''; echo ''; echo ''; echo ''; echo ''

cursec=`date '+%s'`
elapsed=$(( $cursec - $startsec ))
if [ $elapsed -gt 120 ]; then
	min=$(( $elapsed / 60 ))
	sec=$(( $elapsed - $min * 60 ))
	elas="${min} [min] ${sec} [sec]"
else
	elas="${elapsed} [sec]"
fi

echo 'The contents of this storage device' > /tmp/erase-log.$disk
echo "$disk ($cap) '$dname'" >> /tmp/erase-log.$disk
echo -n 'were erased with ' >> /tmp/erase-log.$disk
echo 'hard disk wiping tool "wipe-out."' >> /tmp/erase-log.$disk
echo "Erase $nstuff times ($stuffs)" >> /tmp/erase-log.$disk
echo " epoch: $startsec -> $cursec" >> /tmp/erase-log.$disk

echo "but NOT verified" > /tmp/verify-log.$disk

echo "completed ($elas)"
echo ''
echo -n 'Press ENTER to return menu...'
read x

exit 0

# EOF
